Compare commits

..

2 Commits

Author SHA1 Message Date
poslop 548475e013 Experimenting with patitions 2025-09-26 13:07:56 -05:00
poslop e2fb042e80 updated image with path and latest deb updates 2025-09-25 10:07:52 -05:00
7 changed files with 159 additions and 211 deletions
+83 -138
View File
@@ -1,31 +1,29 @@
#!/bin/bash #!/bin/bash
set -e set -e
# THE RAINBOW HAHAHAH
RED='\e[31m' RED='\e[31m'
GREEN='\e[32m' GREEN='\e[32m'
YELLOW='\e[33m' YELLOW='\e[33m'
RESET='\e[0m' RESET='\e[0m'
MOUNT_POINTS=("/dev" "/dev/pts" "/proc" "/sys" "/sys/firmware/efi/efivars" "/run") # root check
IMG_FILE="PBX.img3.lz4" if [[ $EUID -ne 0 ]]; then
NO_WRITE=false echo -e "${RED}You must be root to do this." 1>&2
NO_RETABLE=false exit 100
NO_USB=false fi
mount_points=("/dev" "/dev/pts" "/proc" "/sys" "/sys/firmware/efi/efivars" "/run")
NO_WRITE=false
# arguments
for arg in "$@"; do for arg in "$@"; do
case $arg in case $arg in
--nowrite) --nowrite)
NO_WRITE=true NO_WRITE=true
shift shift
;; ;;
--noretable)
NO_RETABLE=true
shift
;;
--nousb)
NO_USB=true
shift
;;
-h) -h)
printf "%-20s %s\n" "Flags:" "Description:" printf "%-20s %s\n" "Flags:" "Description:"
echo echo
@@ -40,153 +38,100 @@ for arg in "$@"; do
esac esac
done done
main() {
root_check
udevadm trigger
lsblk
echo
read -rp "Enter the target disk (e.g., sda): " disk_suffix
disk_name="/dev/${disk_suffix}"
echo "Chose disk $disk_name"
echo
trap 'echo "Status Code: $?"; cleanup;' EXIT
if [[ $NO_RETABLE == true ]]; then
echo -e "${YELLOW}--noretable is specified. Tables will not be erased and no partitions will be created${RESET}"
else
rewrite_gpt_table
make_filesystem
fi
if [[ $NO_WRITE == true ]]; then
echo -e "${YELLOW}--nowrite is specified. No need for Img no disks will be written to${RESET}"
fi
# Resize physical volume
echo "Resizing physical volume..."
pvresize $(get_partition $disk_name "3") || true
# Resize swap and root logical volumes
echo "Resizing swap and root volumes..."
#lvresize -L +7G PBX-vg/swap_1
lvresize -l +100%FREE --resizefs PBX-vg/root
echo "Generating fstab..."
boot_uuid=$()
cp ./fstab_template ${mount_path}/etc/fstab
sed --in-place "s/boot_uuid/$(get_partuuid $disk_name "2")/g" ${mount_path}/etc/fstab
sed --in-place "s/efi_uuid/$(get_partuuid $disk_name "1")/g" ${mount_path}/etc/fstab
# Chroot and reinstall GRUB
echo "Entering chroot to reinstall GRUB..."
chroot $mount_path /bin/bash -c "
grub-install --target=x86_64-efi --efi-directory=/boot/efi --bootloader-id=debian
update-grub
"
echo -e "${GREEN}Restore and resize complete!${RESET}"
}
write_img() {
img_file_dir="null"
if [[ -f "./${IMG_FILE}" ]]; then
img_file_dir="./${IMG_FILE}"
elif [[ ! -f "./Image/${IMG_FILE}" ]]; then
img_file_dir="./Image/${IMG_FILE}"
else
img_file_dir="null"
fi
echo "Writing image to $(get_partition $disk_name "3")..."
lz4 -dc ${img_file_dir} | dd of=$(get_partition $disk_name "3") status=progress
partprobe || true
}
rewrite_gpt_table() {
sgdisk -Z $disk_name
sgdisk -c $disk_name
sgdisk -n 1:1MiB:+512M -t 1:ef00 -c 1:"EFI System" $disk_name
sgdisk -n 2:0:+1G -t 2:8300 -c 2:"boot" $disk_name
sgdisk -n 3:0:0 -t 3:8e00 -c 3:"Linux LVM" $disk_name
partprobe || true
}
make_filesystem() {
mkfs.vfat -F 32 $(get_partition $disk_name "1")
mkfs.ext4 $(get_partition $disk_name "2")
}
root_check() {
if [[ $EUID -ne 0 ]]; then
echo -e "${RED}You must be root to do this." 1>&2
exit 100
fi
}
cleanup() { cleanup() {
echo "Cleaning Mounts" echo "Cleaning Mounts"
umount -lf /mnt/ventoy 2>/dev/null || true umount -lf /mnt/ventoy 2>/dev/null || true
for i in "${MOUNT_POINTS[@]}"; do umount -lf "/mnt/debian$i" 2>/dev/null || true; done for i in "${mount_points[@]}"; do umount -lf "/mnt/debian$i" 2>/dev/null || true; done
umount -lf /mnt/debian/boot/efi 2>/dev/null || true umount -lf /mnt/debian/boot/efi 2>/dev/null || true
umount -lf /mnt/debian/boot 2>/dev/null || true umount -lf /mnt/debian/boot 2>/dev/null || true
umount -lf /mnt/debian 2>/dev/null || true umount -lf /mnt/debian 2>/dev/null || true
} }
trap 'echo "Status Code: $?"; cleanup;' EXIT
get_partition() { # Set your target disk here
local disk_name="$1" udevadm trigger
local part_num="$2"
local part_path="$( lsblk
lsblk -lnp -o NAME,TYPE "$disk_name" | echo
awk '$2=="part"{print $1}' |
sed -n "${part_num}p"
)"
printf "$part_path"
}
get_partuuid() {
local disk_name="$1"
local part_num="$2"
local part_uuid="$( read -rp "Enter the target disk (e.g., sda): " disk_suffix
lsblk -ln -o PATH,PARTUUID $disk_name | awk '$1==$(get_partition $disk_name $part_num) {print $2}' disk_name="/dev/${disk_suffix}"
)"
printf "$part_uuid" echo "Chose disk $disk_name"
} echo
mount_chroot() { if [[ $NO_WRITE == true ]]; then
vgchange -ay PBX-vg echo -e "${YELLOW}--nowrite is specified no need for Img no disks will be written to${RESET}"
else
read -rp "Enter the name of the usb partition in /dev/mapper (e.g., sda1): " disk_suffix
mount_path="/mnt/debian" usb_name="/dev/mapper/${disk_suffix}"
echo "Mounting restored system..." user_response="n"
mkdir -p $mount_path/boot read -rp "$(echo -e "${RED}You are about to WRITE and ERASE disk ${disk_name} | Are you sure? y/N: ${RESET}")" user_response
mount /dev/mapper/PBX--vg-root $mount_path
mount $(get_partition $disk_name "2") ${mount_path}/boot
mkdir -p $mount_path/boot/efi if [[ $user_response != y ]]; then
mount $(get_partition $disk_name "1") ${mount_path}/boot/efi echo "Exiting script"
exit
fi
for i in "${MOUNT_POINTS[@]}"; do mount -B $i ${mount_path}${i}; done echo "Mounting Ventoy..."
} mkdir -p /mnt/ventoy
mount $usb_name /mnt/ventoy
cd /mnt/ventoy/Images
echo "Writing image to $disk_name..."
lz4 -dc PBX.img.lz4 | dd of=$disk_name status=progress
fi
# Repartition disk using sgdisk
echo "Repairing partition tables"
sgdisk -e $disk_name
sgdisk -v $disk_name
partprobe || true
echo "Expanding Partition 3 on $disk_name..."
sgdisk --delete=3 $disk_name
sgdisk --new=3:0:0 --typecode=3:8e00 --change-name=3:"Linux LVM" $disk_name
partprobe || true
# Resize physical volume
echo "Resizing physical volume..."
pvresize ${disk_name}3 || true
# Resize swap and root logical volumes
echo "Resizing swap and root volumes..."
lvresize -L +7G PBX-vg/swap_1
lvresize -l +100%FREE --resizefs PBX-vg/root
# Mount restored system for chroot
echo "Mounting restored system..."
mkdir -p /mnt/debian
mount /dev/mapper/PBX--vg-root /mnt/debian/
mount ${disk_name}2 /mnt/debian/boot
mount ${disk_name}1 /mnt/debian/boot/efi
for i in "${mount_points[@]}"; do mount -B $i /mnt/debian$i; done
# Chroot and reinstall GRUB
echo "Entering chroot to reinstall GRUB..."
chroot /mnt/debian /bin/bash -c "
grub-install --target=x86_64-efi --efi-directory=/boot/efi --bootloader-id=debian
update-grub
"
echo -e "${GREEN}Restore and resize complete!${RESET}"
main
cleanup cleanup
+35 -13
View File
@@ -58,12 +58,16 @@ udevadm trigger
lsblk lsblk
echo echo
echo "Enter disk 1 for raid (e.g., sdb): "
read disk_0_suffix
echo "Enter disk 2 for raid (e.g., sdc): "
read disk_1_suffix
read -rp "Enter the target disk (e.g., sda): " disk_suffix disk_name_0="/dev/${disk_suffix}"
disk_name="/dev/${disk_suffix}" disk_name_1="/dev/${disk_suffix}"
echo "Chose disk $disk_name" echo "Raid0 will be configured on $disk_name_0 and $disk_name_1"
echo echo
if [[ $NO_WRITE == true ]]; then if [[ $NO_WRITE == true ]]; then
@@ -82,28 +86,43 @@ else
exit exit
fi fi
for disk in "$disk_name_0" "$disk_name_1"; do
echo "Partitioning $disk..."
sgdisk --zap-all "$disk"
sgdisk -n 1:0:+512M -t 1:ef00 -c 1:"EFI System" "$disk"
sgdisk -n 2:0:+1G -t 2:8300 -c 2:"Boot" "$disk"
sgdisk -n 3:0:0 -t 3:8300 -c 3:"Root" "$disk"
done
mdadm --create /dev/md0 --level=1 --raid-devices=2 "${disk_name_0}2" "${disk_name_1}2"
mdadm --create /dev/md1 --level=1 --raid-devices=2 "${disk_name_0}3" "${disk_name_1}3"
disk_name=/dev/md1
echo "Mounting Ventoy..." echo "Mounting Ventoy..."
mkdir -p /mnt/ventoy mkdir -p /mnt/ventoy
mount $usb_name /mnt/ventoy mount $usb_name /mnt/ventoy
cd /mnt/ventoy/Images cd /mnt/ventoy/Images
echo "Writing image to $disk_name..." echo "Writing image to $disk_name..."
lz4 -dc PBX-LVM.img.lz4 | dd of=$disk_name status=progress lz4 -dc PBX3.img.lz4 | dd of=$disk_name status=progress
fi fi
# echo "Repairing partition tables"
# Repartition disk using sgdisk # sgdisk -e $disk_name
echo "Repairing partition tables" # sgdisk -v $disk_name
sgdisk -e $disk_name
sgdisk -v $disk_name
partprobe || true partprobe || true
echo "Expanding Partition 3 on $disk_name..." # echo "Expanding Partition 3 on $disk_name..."
sgdisk --delete=3 $disk_name # sgdisk --delete=3 $disk_name
sgdisk --new=3:0:0 --typecode=3:8e00 --change-name=3:"Linux LVM" $disk_name # sgdisk --new=3:0:0 --typecode=3:8e00 --change-name=3:"Linux LVM" $disk_name
partprobe || true # partprobe || true
# Resize physical volume # Resize physical volume
echo "Resizing physical volume..." echo "Resizing physical volume..."
@@ -125,11 +144,14 @@ mount ${disk_name}1 /mnt/debian/boot/efi
for i in "${mount_points[@]}"; do mount -B $i /mnt/debian$i; done for i in "${mount_points[@]}"; do mount -B $i /mnt/debian$i; done
mdadm --detail --scan >> /mnt/debian/etc/mdadm/mdadm.conf
# Chroot and reinstall GRUB # Chroot and reinstall GRUB
echo "Entering chroot to reinstall GRUB..." echo "Entering chroot to reinstall GRUB..."
chroot /mnt/debian /bin/bash -c " chroot /mnt/debian /bin/bash -c "
grub-install --target=x86_64-efi --efi-directory=/boot/efi --bootloader-id=debian grub-install --target=x86_64-efi --efi-directory=/boot/efi --bootloader-id=debian
update-grub update-grub
update-initramfs -u
" "
echo -e "${GREEN}Restore and resize complete!${RESET}" echo -e "${GREEN}Restore and resize complete!${RESET}"
BIN
View File
Binary file not shown.
BIN
View File
Binary file not shown.
+14 -9
View File
@@ -1,28 +1,33 @@
#!/bin/bash #!/bin/bash
set -e set -e
# THE RAINBOW HAHAHAH
RED='\e[31m' RED='\e[31m'
GREEN='\e[32m' GREEN='\e[32m'
YELLOW='\e[33m' YELLOW='\e[33m'
RESET='\e[0m' RESET='\e[0m'
img_file="PBX-Test.img" # root check
if [[ $EUID -ne 0 ]]; then if [[ $EUID -ne 0 ]]; then
echo -e "${RED}You must be root to do this." 1>&2 echo -e "${RED}You must be root to do this." 1>&2
exit 100 exit 100
fi fi
losetup -fP $img_file echo "Converting to IMG"
loop_device=$(losetup -l | grep $img_file | cut -d ' ' -f1) #qemu-img convert -f qcow2 -O raw PBX.qcow2 PBX.img
losetup -fP PBX.img
loop_device=$(losetup -l | grep "PBX.img" | cut -d ' ' -f1)
echo $loop_device echo $loop_device
vgchange -a y PBX-vg vgchange -a y PBX-vg
lvreduce -L 14G -r PBX-vg/root
lvreduce -L 976M PBX-vg/swap_1
lvreduce -L 12G -r PBX-vg/root sgdisk --delete=3 $loop_device
sgdisk --new=3:+0:+15G --typecode=3:8e00 --change-name=3:"Linux LVM" $loop_device
partclone.ext4 -c -s /dev/mapper/PBX--vg-root | lz4 -z >./PBX-root.img.lz4
vgchange -a n PBX-vg vgchange -a n PBX-vg
losetup -D #dd if=/dev/loop0p3 bs=64M conv=sync status=progress | lz4 -z > ./PBX3.img.lz4
#losetup -D
-2
View File
@@ -1,2 +0,0 @@
## Used for writing a Debian FreePBX image to a new drive
WIP
-19
View File
@@ -1,19 +0,0 @@
# /etc/fstab: static file system information.
#
# Use 'blkid' to print the universally unique identifier for a
# device; this may be used with UUID= as a more robust way to name devices
# that works even if disks are added and removed. See fstab(5).
#
# systemd generates mount units based on this file, see systemd.mount(5).
# Please run 'systemctl daemon-reload' after making changes here.
# <file system> <mount point> <type> <options> <dump> <pass>
/dev/mapper/PBX--vg-root / ext4 errors=remount-ro 0 1
# /boot was on /dev/vda2 during installation
UUID=BOOT_UUID /boot ext2 defaults 0 2
# /boot/efi was on /dev/vda1 during installation
UUID=EFI_UUID /boot/efi vfat umask=0077 0 1
/dev/mapper/PBX--vg-swap_1 none swap sw 0 0